GNU bug report logs - #14120
invalid load-history in emacsen that CANNOT_DUMP

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: BT Templeton <bt@HIDDEN>; dated Mon, 1 Apr 2013 22:55:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Disconnected #34094 from all other report(s). Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Forcibly Merged 14120 34094. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 14120 <at> debbugs.gnu.org:


Received: (at 14120) by debbugs.gnu.org; 3 Apr 2013 18:32:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 03 14:32:47 2013
Received: from localhost ([127.0.0.1]:60447 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1UNSUJ-0001Uj-2b
	for submit <at> debbugs.gnu.org; Wed, 03 Apr 2013 14:32:47 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:54682)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1UNSUI-0001Ud-7v
	for 14120 <at> debbugs.gnu.org; Wed, 03 Apr 2013 14:32:46 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av4EABK/CFFFxLSu/2dsb2JhbABEvw4Xc4IeAQEEAVYjBQsLNBIUGA0kiB4GwS2RCgOfXIUegV6DE4FKJA
X-IPAS-Result: Av4EABK/CFFFxLSu/2dsb2JhbABEvw4Xc4IeAQEEAVYjBQsLNBIUGA0kiB4GwS2RCgOfXIUegV6DE4FKJA
X-IronPort-AV: E=Sophos;i="4.84,565,1355115600"; 
   d="scan'208";a="6403866"
Received: from 69-196-180-174.dsl.teksavvy.com (HELO pastel.home)
	([69.196.180.174])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	03 Apr 2013 14:29:37 -0400
Received: by pastel.home (Postfix, from userid 20848)
	id 3603567A1E; Wed,  3 Apr 2013 14:29:40 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: BT Templeton <bt@HIDDEN>
Subject: Re: bug#14120: invalid load-history in emacsen that CANNOT_DUMP
Message-ID: <jwv8v4zfp1g.fsf-monnier+emacs@HIDDEN>
References: <87fvz9rhqq.fsf@HIDDEN>
Date: Wed, 03 Apr 2013 14:29:40 -0400
In-Reply-To: <87fvz9rhqq.fsf@HIDDEN> (BT Templeton's message of "Mon, 
	01 Apr 2013 18:47:09 -0400")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 14120
Cc: 14120 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.0 (/)

> However, when Emacs is built with CANNOT_DUMP defined, "loadup.el"
> evaluates `top-level' instead of dumping.

FWIW, CANNOT_DUMP is a compilation option that is only meant to be used
as a temporary measure.  It suffers from various shortcomings (other
than the obvious startup cost).

So before we start trying to fix them, I'd like to know why you need to
use CANNOT_DUMP.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#14120; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 1 Apr 2013 22:54:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 01 18:54:05 2013
Received: from localhost ([127.0.0.1]:56695 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1UMnc4-0002kF-66
	for submit <at> debbugs.gnu.org; Mon, 01 Apr 2013 18:54:04 -0400
Received: from eggs.gnu.org ([208.118.235.92]:34749)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bt@HIDDEN>) id 1UMnZD-0002fe-K1
	for submit <at> debbugs.gnu.org; Mon, 01 Apr 2013 18:51:08 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <bt@HIDDEN>) id 1UMnWM-0005nI-92
	for submit <at> debbugs.gnu.org; Mon, 01 Apr 2013 18:48:12 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-4.2 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
	autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:38864)
	by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <bt@HIDDEN>)
	id 1UMnWM-0005nE-5q
	for submit <at> debbugs.gnu.org; Mon, 01 Apr 2013 18:48:10 -0400
Received: from eggs.gnu.org ([208.118.235.92]:46101)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <bt@HIDDEN>) id 1UMnWJ-0002nu-AU
	for bug-gnu-emacs@HIDDEN; Mon, 01 Apr 2013 18:48:10 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <bt@HIDDEN>) id 1UMnWH-0005mZ-5F
	for bug-gnu-emacs@HIDDEN; Mon, 01 Apr 2013 18:48:07 -0400
Received: from deleuze.hcoop.net ([69.90.123.67]:39378)
	by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <bt@HIDDEN>)
	id 1UMnWH-0005m1-1W
	for bug-gnu-emacs@HIDDEN; Mon, 01 Apr 2013 18:48:05 -0400
Received: from cpe-071-070-253-241.nc.res.rr.com ([71.70.253.241]
	helo=olor.terpri.org)
	by deleuze.hcoop.net with esmtpsa (TLS-1.0:DHE_RSA_AES_128_CBC_SHA1:16)
	(Exim 4.63) (envelope-from <bt@HIDDEN>) id 1UMnWB-0003Cf-24
	for bug-gnu-emacs@HIDDEN; Mon, 01 Apr 2013 18:47:59 -0400
From: BT Templeton <bt@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: invalid load-history in emacsen that CANNOT_DUMP
Date: Mon, 01 Apr 2013 18:47:09 -0400
Message-ID: <87fvz9rhqq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.4.x-2.6.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Mon, 01 Apr 2013 18:54:03 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

"loadup.el" sets `current-load-list' to nil, apparently so that it will
have that value when restarting a dumped emacs. However, when Emacs is
built with CANNOT_DUMP defined, "loadup.el" evaluates `top-level'
instead of dumping. This can lead to invalid entries in `load-history'
if something is defined, required, etc. during evaluation of that form.

For example, load-history will contain `((require . tetris))' if
~/.emacs defines this hook:

(add-hook 'lisp-interaction-mode-hook
          (lambda () (require 'tetris)))

For `require', the problem can be fixed by also setting
`load-in-progress' to nil in "loadup.el", but this doesn't fix the bug
for other functions that change the load history.

-- 
Inteligenta persono lernas la lingvon Esperanton rapide kaj facile.
Esperanto estas moderna, kultura lingvo por la mondo. Simpla, fleksebla,
belsona, Esperanto estas la praktika solvo de la problemo de universala
interkompreno. Lernu la interlingvon Esperanton!




Acknowledgement sent to BT Templeton <bt@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#14120; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 16 Jan 2019 10:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.